<br />

This page describes exporting and importing data into Cloud SQL instances using
SQL dump files.

> [!NOTE]
> **Note:**
> If you're migrating an entire database from
> a supported database server (on-premises, in AWS, or Cloud SQL) to a new
> Cloud SQL instance, you can use
> [Database Migration Service](https://docs.cloud.google.com/database-migration/docs.md.txt) instead of exporting
> and then importing files. If you're exporting to create a new
> instance from the exported file, consider
> [restoring from a backup to a different instance](https://docs.cloud.google.com/sql/docs/postgres/backup-recovery/restoring.md.txt#restorebackups-another-instance)
> or [cloning the instance](https://docs.cloud.google.com/sql/docs/postgres/clone-instance.md.txt).
>
> You can cancel the import of data into Cloud SQL instances and
> the export of data from the instances.
> This data is contained in SQL dump files. For
> more information about cancelling an import or export operation, see [Cancel the import
> and export of data](https://docs.cloud.google.com/sql/docs/postgres/import-export/cancel-import-export).

## Before you begin

> [!IMPORTANT]
> **Important:** Before starting a large export, ensure that at least 25 percent of the database size is free (on the instance). Doing so helps prevent issues with aggressive autogrowth, which can affect the availability of the instance.

Exports use database resources, but they do not interfere with normal database
operations unless the instance is under-provisioned.

For best practices, see
[Best Practices for Importing and
Exporting Data](https://docs.cloud.google.com/sql/docs/postgres/import-export).

After completing an import operation,
[verify](https://docs.cloud.google.com/sql/docs/postgres/import-export.md.txt#verify) the
results.

<br />

## Export data from Cloud SQL for PostgreSQL

### Required roles and permissions for exporting from Cloud SQL for PostgreSQL


To export
data from Cloud SQL into Cloud Storage, the user initiating the export must have
one of the following roles:

- The [Cloud SQL Editor](https://docs.cloud.google.com/sql/docs/postgres/iam-roles.md.txt) role
- A [custom role](https://docs.cloud.google.com/iam/docs/understanding-custom-roles), including the following permissions:
  - `cloudsql.instances.get`
  - `cloudsql.instances.export`

Additionally, the service account for the Cloud SQL instance must have one of the following roles:


- The `storage.objectAdmin` Identity and Access Management (IAM) role
- A custom role, including the following permissions:
  - `storage.objects.create`
  - `storage.objects.list` (for exporting files in parallel only)
  - `storage.objects.delete` (for exporting files in parallel only)

For help with
IAM roles, see
[Identity and Access Management](https://docs.cloud.google.com/storage/docs/access-control/iam.md.txt).

> [!NOTE]
> **Note** : The changes that you make to the IAM permissions and roles might take a few minutes to take effect. For more information, see [Access change propagation](https://docs.cloud.google.com/iam/docs/access-change-propagation.md.txt).

<br />

### Export to a SQL dump file from Cloud SQL for PostgreSQL

When you use Cloud SQL to perform an export, whether from the Google Cloud console, the [gcloud CLI](https://docs.cloud.google.com/sdk/gcloud.md.txt), or the API, you are using the [`pg_dump`](https://www.postgresql.org/docs/current/static/app-pgdump.html) utility, with the options required to ensure that the resulting export file is valid for import back into Cloud SQL.

<br />

If you plan to import your data into Cloud SQL, you must follow the
instructions provided in [Exporting data from an external database server](https://docs.cloud.google.com/sql/docs/postgres/import-export/import-export-dmp.md.txt#external-server)
so that your SQL dump file is formatted correctly for Cloud SQL.

> [!NOTE]
> **Note:** If your data contains large objects (blobs), the export can consume a large amount of memory, impacting instance performance. For help, see [Known Issues](https://docs.cloud.google.com/sql/docs/postgres/known-issues.md.txt#import-export).

To export data from a database on a Cloud SQL instance to a SQL dump file
in a Cloud Storage bucket:

### Console

1. In the Google Cloud console, go to the **Cloud SQL Instances** page.

   [Go to Cloud SQL Instances](https://console.cloud.google.com/sql)
2. To open the **Overview** page of an instance, click the instance name.
3. Click **Export**.
4. In the **File format** section, click **SQL** to create a SQL dump file.
5. In the **Data to export** section, use the **Database** drop-down menu to select the database you want to export from.
6. Optional: Select **Offload export to a temporary instance** to allow other operations to occur while the export is ongoing.
7. In the **Destination** section, select **Browse** to search for a Cloud Storage bucket or folder for your export.
8. Click **Export** to begin the export.

### gcloud

1. [Create a Cloud Storage bucket](https://docs.cloud.google.com/storage/docs/creating-buckets.md.txt).
2. Find the service account for the Cloud SQL instance you're exporting from. You can do this running the `gcloud sql instances describe` command. Look for the `serviceAccountEmailAddress` field in the output.

   ```bash
   gcloud sql instances describe INSTANCE_NAME
     
   ```
3. Use `gcloud
   storage buckets add-iam-policy-binding` to grant the `storage.objectAdmin` [IAM role](https://docs.cloud.google.com/storage/docs/access-control/iam-roles.md.txt) to the service account. For help with setting IAM permissions, see [Using IAM permissions](https://docs.cloud.google.com/storage/docs/access-control/using-iam-permissions.md.txt).
4. Export the database to your Cloud Storage bucket: **Note** : If you want to use
   serverless exports, then use the `offload` parameter. If you want to include the `DROP <object>` SQL statement that's required to drop (clean) database objects before you import them, then use the `clean` parameter. If you want to include the `IF EXISTS` SQL statement with each `DROP` statement that's produced by the `clean` parameter, then use the `if-exists` parameter.

   Otherwise, remove these parameters from the following command.

   ```
   gcloud sql export sql INSTANCE_NAME gs://BUCKET_NAME/sqldumpfile.gz \
   --database=DATABASE_NAME \
   --offload \
   --clean \
   --if-exists
     
   ```

   The `export sql` command contains triggers, functions, and
   stored procedures for PostgreSQL databases.

   For more information about using the `export sql` command, see the
   [`sql export sql`](https://docs.cloud.google.com/sdk/gcloud/reference/sql/export/sql.md.txt)
   command reference page.
5. If you do not need to retain the IAM role you set previously, [revoke](https://docs.cloud.google.com/iam/docs/granting-changing-revoking-access.md.txt#revoking-console) it now.

### REST v1

1. Create a bucket for the export:

   ```bash
   gcloud storage buckets create gs://BUCKET_NAME --project=PROJECT_NAME --location=LOCATION_NAME
   ```

   This step is not required, but strongly recommended, so you do not open up
   access to any other data.
2. Provide your instance with the `storage.objectAdmin` [IAM role](https://docs.cloud.google.com/storage/docs/access-control/iam-roles.md.txt) for your bucket. For help with setting IAM permissions, see [Using
   IAM permissions](https://docs.cloud.google.com/storage/docs/access-control/using-iam-permissions).
3. Export your database:
   Before using any of the request data,
   make the following replacements:

   - <var translate="no">PROJECT_ID</var>: the project ID
   - <var translate="no">INSTANCE_ID</var>: the instance ID
   - <var translate="no">BUCKET_NAME</var>: the Cloud Storage bucket name
   - <var translate="no">PATH_TO_DUMP_FILE</var>: the path to the SQL dump file
   - <var translate="no">DATABASE_NAME_1</var>: the name of a database inside the Cloud SQL instance
   - <var translate="no">DATABASE_NAME_2</var>: the name of a database inside the Cloud SQL instance

   > [!NOTE]
   > **Note** : If you want to use serverless exports, then use the `offload` parameter. If you want to include the `DROP <object>` SQL statement that's required to drop (clean) database objects before you import them, then use the `clean` parameter. If you want to include the `IF EXISTS` SQL statement with each `DROP` statement that's produced by the `clean` parameter, then use the `ifExists` parameter.
   >
   > To use these features, set the values of these parameters to `TRUE`. Otherwise, set their values to `FALSE`.
   >
   > Serverless exports costs extra. See the
   > [pricing page](https://cloud.google.com/sql/pricing#storage-networking-prices).


   HTTP method and URL:

   ```
   POST https://sqladmin.googleapis.com/v1/projects/PROJECT_ID/instances/INSTANCE_ID/export
   ```


   Request JSON body:

   ```
   {
     "exportContext":
       {
          "fileType": "SQL",
          "uri": "gs://BUCKET_NAME/PATH_TO_DUMP_FILE",
          "databases": ["DATABASE_NAME"],
          "offload": TRUE | FALSE,
          "sqlExportOptions": {
           "clean": [TRUE|FALSE],
           "ifExists": [TRUE|FALSE]
          }
       }
    }
   ```

   To send your request, expand one of these options:

   #### curl (Linux, macOS, or Cloud Shell)

   > [!NOTE]
   > **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) , or by using [Cloud Shell](https://docs.cloud.google.com/shell/docs.md.txt), which automatically logs you into the `gcloud` CLI . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


   Save the request body in a file named `request.json`,
   and execute the following command:

   ```
   curl -X POST \
        -H "Authorization: Bearer $(gcloud auth print-access-token)" \
        -H "Content-Type: application/json; charset=utf-8" \
        -d @request.json \
        "https://sqladmin.googleapis.com/v1/projects/PROJECT_ID/instances/INSTANCE_ID/export"
   ```

   #### PowerShell (Windows)

   > [!NOTE]
   > **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


   Save the request body in a file named `request.json`,
   and execute the following command:

   ```
   $cred = gcloud auth print-access-token
   $headers = @{ "Authorization" = "Bearer $cred" }

   Invoke-WebRequest `
       -Method POST `
       -Headers $headers `
       -ContentType: "application/json; charset=utf-8" `
       -InFile request.json `
       -Uri "https://sqladmin.googleapis.com/v1/projects/PROJECT_ID/instances/INSTANCE_ID/export" | Select-Object -Expand Content
   ```

   You should receive a JSON response similar to the following:

   #### Response

   ```
   {
     "kind": "sql#operation",
     "targetLink": "https://sqladmin.googleapis.com/v1/projects/PROJECT_ID/instances/TARGET_INSTANCE_ID",
     "status": "PENDING",
     "user": "user@example.com",
     "insertTime": "2020-01-21T22:43:37.981Z",
     "operationType": "UPDATE",
     "name": "OPERATION_ID",
     "targetId": "INSTANCE_ID",
     "selfLink": "https://sqladmin.googleapis.com/v1/projects/PROJECT_ID/operations/OPERATION_ID",
     "targetProject": "PROJECT_ID"
   }
   ```
4. If you do not need to retain the IAM role you set previously, remove it now.

For the complete list of parameters for the request, see the [instances:export](https://docs.cloud.google.com/sql/docs/postgres/admin-api/rest/v1beta4/instances/export.md.txt) page.

### REST v1beta4

1. Create a bucket for the export:

   ```
   gcloud storage buckets create gs://BUCKET_NAME --project=PROJECT_NAME --location=LOCATION_NAME
   ```

   This step is not required, but strongly recommended, so you do not open up
   access to any other data.
2. Provide your instance with the `storage.objectAdmin` [IAM role](https://docs.cloud.google.com/storage/docs/access-control/iam-roles.md.txt) for your bucket. For help with setting IAM permissions, see [Using
   IAM permissions](https://docs.cloud.google.com/storage/docs/access-control/using-iam-permissions).
3. Export your database:
   Before using any of the request data,
   make the following replacements:

   - <var translate="no">PROJECT_ID</var>: the project ID
   - <var translate="no">INSTANCE_ID</var>: the instance ID
   - <var translate="no">BUCKET_NAME</var>: the Cloud Storage bucket name
   - <var translate="no">PATH_TO_DUMP_FILE</var>: the path to the SQL dump file
   - <var translate="no">DATABASE_NAME_1</var>: the name of a database inside the Cloud SQL instance
   - <var translate="no">DATABASE_NAME_2</var>: the name of a database inside the Cloud SQL instance

   > [!NOTE]
   > **Note** : If you want to use serverless exports, then use the `offload` parameter. If you want to include the `DROP <object>` SQL statement that's required to drop (clean) database objects before you import them, then use the `clean` parameter. If you want to include the `IF EXISTS` SQL statement with each `DROP` statement that's produced by the `clean` parameter, then use the `ifExists` parameter.
   >
   > To use these features, set the values of these parameters to `TRUE`. Otherwise, set their values to `FALSE`.
   >
   > Serverless exports costs extra. See the
   > [pricing page](https://cloud.google.com/sql/pricing#storage-networking-prices).


   HTTP method and URL:

   ```
   POST https://sqladmin.googleapis.com/sql/v1beta4/projects/PROJECT_ID/instances/INSTANCE_ID/export
   ```


   Request JSON body:

   ```
   {
      "exportContext":
        {
           "fileType": "SQL",
           "uri": "gs://BUCKET_NAME/PATH_TO_DUMP_FILE",
           "databases": ["DATABASE_NAME"],
           "offload": TRUE | FALSE,
           "sqlExportOptions": {
            "clean": [TRUE|FALSE],
            "ifExists": [TRUE|FALSE]
           }
        }
     }
   ```

   To send your request, expand one of these options:

   #### curl (Linux, macOS, or Cloud Shell)

   > [!NOTE]
   > **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) , or by using [Cloud Shell](https://docs.cloud.google.com/shell/docs.md.txt), which automatically logs you into the `gcloud` CLI . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


   Save the request body in a file named `request.json`,
   and execute the following command:

   ```
   curl -X POST \
        -H "Authorization: Bearer $(gcloud auth print-access-token)" \
        -H "Content-Type: application/json; charset=utf-8" \
        -d @request.json \
        "https://sqladmin.googleapis.com/sql/v1beta4/projects/PROJECT_ID/instances/INSTANCE_ID/export"
   ```

   #### PowerShell (Windows)

   > [!NOTE]
   > **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


   Save the request body in a file named `request.json`,
   and execute the following command:

   ```
   $cred = gcloud auth print-access-token
   $headers = @{ "Authorization" = "Bearer $cred" }

   Invoke-WebRequest `
       -Method POST `
       -Headers $headers `
       -ContentType: "application/json; charset=utf-8" `
       -InFile request.json `
       -Uri "https://sqladmin.googleapis.com/sql/v1beta4/projects/PROJECT_ID/instances/INSTANCE_ID/export" | Select-Object -Expand Content
   ```

   You should receive a JSON response similar to the following:

   #### Response

   ```
   {
     "kind": "sql#operation",
     "targetLink": "https://sqladmin.googleapis.com/sql/v1beta4/projects/PROJECT_ID/instances/TARGET_INSTANCE_ID",
     "status": "PENDING",
     "user": "user@example.com",
     "insertTime": "2020-01-21T22:43:37.981Z",
     "operationType": "UPDATE",
     "name": "OPERATION_ID",
     "targetId": "INSTANCE_ID",
     "selfLink": "https://sqladmin.googleapis.com/sql/v1beta4/projects/PROJECT_ID/operations/OPERATION_ID",
     "targetProject": "PROJECT_ID"
   }
   ```
4. If you do not need to retain the IAM role you set previously, [revoke](https://docs.cloud.google.com/iam/docs/granting-changing-revoking-access.md.txt#revoking-console) it now.

For the complete list of parameters for the request, see the [instances:export](https://docs.cloud.google.com/sql/docs/postgres/admin-api/rest/v1beta4/instances/export.md.txt) page.

## Import data to Cloud SQL for PostgreSQL

### Required roles and permissions for importing to Cloud SQL for PostgreSQL


To import
data from Cloud Storage into Cloud SQL, the user initiating the import must have
one of the following roles:

- The [Cloud SQL Admin](https://docs.cloud.google.com/sql/docs/postgres/iam-roles.md.txt) role
- A [custom role](https://docs.cloud.google.com/iam/docs/understanding-custom-roles), including the following permissions:
  - `cloudsql.instances.get`
  - `cloudsql.instances.import`

Additionally, the service account for the Cloud SQL instance must have one of the following roles:


- The `storage.objectAdmin` IAM role
- A custom role, including the following permissions:
  - `storage.objects.get`
  - `storage.objects.list` (for importing files in parallel only)

For help with
IAM roles, see
[Identity and Access Management](https://docs.cloud.google.com/storage/docs/access-control/iam.md.txt).

> [!NOTE]
> **Note** : The changes that you make to the IAM permissions and roles might take a few minutes to take effect. For more information, see [Access change propagation](https://docs.cloud.google.com/iam/docs/access-change-propagation.md.txt).

<br />

### Import a SQL dump file to Cloud SQL for PostgreSQL

SQL files are plain text files with a sequence of SQL commands.

### Console

1. In the Google Cloud console, go to the **Cloud SQL Instances** page.

   [Go to Cloud SQL Instances](https://console.cloud.google.com/sql)
2. To open the **Overview** page of an instance, click the instance name.
3. Click **Import**.
4. In the **File format** section, select **SQL**.
5. In the **Select source file** section, enter the path to the bucket and SQL dump file to use for the import, browse to an existing file, or upload a local file.

   You can import a compressed (`.gz`) or an uncompressed
   (`.sql`) file.
6. In the **Destination** section, select the database that you want the
   data to be imported into.

   This causes Cloud SQL to run the
   `USE DATABASE_NAME` statement before the import.

   If your SQL dump file includes a
   `USE DATABASE_NAME` statement, it overrides the
   database that you select in the Google Cloud console.
7. If you want to specify a user to perform the import,
   select the user.


   If your import file contains statements that must be performed
   by a specific user, use this field to specify that user.
8. Click **Import** to start the import.

### gcloud

1. [Create a Cloud Storage bucket.](https://docs.cloud.google.com/storage/docs/creating-buckets.md.txt)
2. Upload the file to your bucket.

   For help with uploading files to buckets, see
   [Uploading objects](https://docs.cloud.google.com/storage/docs/uploading-objects.md.txt).
3. Describe the instance you are importing to:

   ```bash
   gcloud sql instances describe INSTANCE_NAME
   ```
4. Copy the `serviceAccountEmailAddress` field.
5. Use `gcloud storage buckets add-iam-policy-binding` to grant the `storage.objectAdmin` [IAM role](https://docs.cloud.google.com/storage/docs/access-control/iam-roles.md.txt) to the service account for the bucket.

   ```bash
   gcloud storage buckets add-iam-policy-binding gs://BUCKET_NAME \
     --member=serviceAccount:SERVICE-ACCOUNT \
     --role=roles/storage.objectAdmin
     
   ```
   For help with setting IAM permissions, see [Using IAM permissions](https://docs.cloud.google.com/storage/docs/access-control/using-iam-permissions.md.txt).
6. Import the database:

   ```bash
   gcloud sql import sql INSTANCE_NAME gs://BUCKET_NAME/IMPORT_FILE_NAME \
   --database=DATABASE_NAME
   ```

   For information about using the `import sql` command, see the
   [`sql import sql`](https://docs.cloud.google.com/sdk/gcloud/reference/sql/import/sql.md.txt)
   command reference page.

   If the command returns an error like `ERROR_RDBMS`, review the
   permissions; this error is often due to permissions issues.
7. If you do not need to retain the IAM permissions you set previously, remove them using `gcloud storage buckets remove-iam-policy-binding`.

### REST v1

1. Create a SQL dump file. The linked instructions set certain flags that make the dump file
   compatible with Cloud SQL.

   - If you are importing data from an on-premises PostgreSQL server:
     1. Create a SQL dump file using the instructions in [Exporting data using pg_dump](https://docs.cloud.google.com/sql/docs/postgres/import-export/exporting#external-server).
     2. Create a bucket in Cloud Storage using the instructions in [Create buckets](https://docs.cloud.google.com/storage/docs/creating-buckets.md.txt).
     3. Upload the SQL dump file to the Cloud Storage bucket using the procedure in [Upload objects](https://docs.cloud.google.com/storage/docs/uploading-objects.md.txt).
2. [Create a Cloud Storage bucket.](https://docs.cloud.google.com/storage/docs/creating-buckets.md.txt)
3. Upload the file to your bucket.

   For help with uploading files to buckets, see
   [Uploading objects](https://docs.cloud.google.com/storage/docs/uploading-objects.md.txt).
4. Provide your instance with the `storage.objectAdmin` and `objectViewer` [IAM roles](https://docs.cloud.google.com/storage/docs/access-control/iam-roles.md.txt) for your bucket. For help with setting IAM permissions, see [Using IAM permissions](https://docs.cloud.google.com/storage/docs/access-control/using-iam-permissions.md.txt).
5. Import your dump file:
   Before using any of the request data,
   make the following replacements:

   - <var translate="no">project-id</var>: The project ID
   - <var translate="no">instance-id</var>: The instance ID
   - <var translate="no">bucket_name</var>: The Cloud Storage bucket name
   - <var translate="no">path_to_sql_file</var>: The path to the SQL file
   - <var translate="no">database_name</var>: The name of a database inside the Cloud SQL instance


   HTTP method and URL:

   ```
   POST https://sqladmin.googleapis.com/v1/projects/project-id/instances/instance-id/import
   ```


   Request JSON body:

   ```
   {
    "importContext":
      {
         "fileType": "SQL",
         "uri": "gs://bucket_name/path_to_sql_file",
         "database": "database_name"
       }
   }

   ```

   To send your request, expand one of these options:

   #### curl (Linux, macOS, or Cloud Shell)

   > [!NOTE]
   > **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) , or by using [Cloud Shell](https://docs.cloud.google.com/shell/docs.md.txt), which automatically logs you into the `gcloud` CLI . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


   Save the request body in a file named `request.json`,
   and execute the following command:

   ```
   curl -X POST \
        -H "Authorization: Bearer $(gcloud auth print-access-token)" \
        -H "Content-Type: application/json; charset=utf-8" \
        -d @request.json \
        "https://sqladmin.googleapis.com/v1/projects/project-id/instances/instance-id/import"
   ```

   #### PowerShell (Windows)

   > [!NOTE]
   > **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


   Save the request body in a file named `request.json`,
   and execute the following command:

   ```
   $cred = gcloud auth print-access-token
   $headers = @{ "Authorization" = "Bearer $cred" }

   Invoke-WebRequest `
       -Method POST `
       -Headers $headers `
       -ContentType: "application/json; charset=utf-8" `
       -InFile request.json `
       -Uri "https://sqladmin.googleapis.com/v1/projects/project-id/instances/instance-id/import" | Select-Object -Expand Content
   ```

   You should receive a JSON response similar to the following:

   #### Response

   ```
   {
     "kind": "sql#operation",
     "targetLink": "https://sqladmin.googleapis.com/v1/projects/project-id/instances/target-instance-id",
     "status": "PENDING",
     "user": "user@example.com",
     "insertTime": "2020-01-21T22:43:37.981Z",
     "operationType": "UPDATE",
     "name": "operation-id",
     "targetId": "instance-id",
     "selfLink": "https://sqladmin.googleapis.com/v1/projects/project-id/operations/operation-id",
     "targetProject": "project-id"
   }
   ```

   To use a different user for the import, specify the
   `importContext.importUser` property.
   For the complete list of parameters for the request, see the [instances:import](https://docs.cloud.google.com/sql/docs/postgres/admin-api/rest/v1beta4/instances/import.md.txt) page.
6. If you do not need to retain the IAM permissions you set previously, remove them now.

### REST v1beta4

1. Create a SQL dump file. The linked instructions set certain flags that make the dump file
   compatible with Cloud SQL.

   - If you are importing data from an on-premises PostgreSQL server:
     1. Create a SQL dump file using the instructions in [Exporting data using pg_dump](https://docs.cloud.google.com/sql/docs/postgres/import-export/exporting#external-server).
     2. Create a bucket in Cloud Storage using the instructions in [Create buckets](https://docs.cloud.google.com/storage/docs/creating-buckets.md.txt).
     3. Upload the SQL dump file to the Cloud Storage bucket using the procedure in [Upload objects](https://docs.cloud.google.com/storage/docs/uploading-objects.md.txt).
2. [Create a Cloud Storage bucket.](https://docs.cloud.google.com/storage/docs/creating-buckets.md.txt)
3. Upload the file to your bucket.

   For help with uploading files to buckets, see
   [Uploading objects](https://docs.cloud.google.com/storage/docs/uploading-objects.md.txt).
4. Provide your instance with the `storage.objectAdmin` [IAM role](https://docs.cloud.google.com/storage/docs/access-control/iam-roles.md.txt) for your bucket. For help with setting IAM permissions, see [Using IAM permissions](https://docs.cloud.google.com/storage/docs/access-control/using-iam-permissions.md.txt).
5. Import your dump file:
   Before using any of the request data,
   make the following replacements:

   - <var translate="no">project-id</var>: The project ID
   - <var translate="no">instance-id</var>: The instance ID
   - <var translate="no">bucket_name</var>: The Cloud Storage bucket name
   - <var translate="no">path_to_sql_file</var>: The path to the SQL file
   - <var translate="no">database_name</var>: The name of a database inside the Cloud SQL instance


   HTTP method and URL:

   ```
   POST https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/instances/instance-id/import
   ```


   Request JSON body:

   ```
   {
    "importContext":
      {
         "fileType": "SQL",
         "uri": "gs://bucket_name/path_to_sql_file",
         "database": "database_name"
       }
   }

   ```

   To send your request, expand one of these options:

   #### curl (Linux, macOS, or Cloud Shell)

   > [!NOTE]
   > **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) , or by using [Cloud Shell](https://docs.cloud.google.com/shell/docs.md.txt), which automatically logs you into the `gcloud` CLI . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


   Save the request body in a file named `request.json`,
   and execute the following command:

   ```
   curl -X POST \
        -H "Authorization: Bearer $(gcloud auth print-access-token)" \
        -H "Content-Type: application/json; charset=utf-8" \
        -d @request.json \
        "https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/instances/instance-id/import"
   ```

   #### PowerShell (Windows)

   > [!NOTE]
   > **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


   Save the request body in a file named `request.json`,
   and execute the following command:

   ```
   $cred = gcloud auth print-access-token
   $headers = @{ "Authorization" = "Bearer $cred" }

   Invoke-WebRequest `
       -Method POST `
       -Headers $headers `
       -ContentType: "application/json; charset=utf-8" `
       -InFile request.json `
       -Uri "https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/instances/instance-id/import" | Select-Object -Expand Content
   ```

   You should receive a JSON response similar to the following:

   #### Response

   ```
   {
     "kind": "sql#operation",
     "targetLink": "https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/instances/target-instance-id",
     "status": "PENDING",
     "user": "user@example.com",
     "insertTime": "2020-01-21T22:43:37.981Z",
     "operationType": "UPDATE",
     "name": "operation-id",
     "targetId": "instance-id",
     "selfLink": "https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/operations/operation-id",
     "targetProject": "project-id"
   }
   ```

   To use a different user for the import, specify the
   `importContext.importUser` property.
   For the complete list of parameters for the request, see the [instances:import](https://docs.cloud.google.com/sql/docs/postgres/admin-api/rest/v1beta4/instances/import.md.txt) page.
6. If you do not need to retain the IAM permissions you set previously, remove them now.

<br />

## What's next

- Learn how to [check the status of import and export operations](https://docs.cloud.google.com/sql/docs/postgres/import-export/checking-status-import-export.md.txt).
- Learn more about [best practices for importing and exporting data](https://docs.cloud.google.com/sql/docs/postgres/import-export.md.txt).
- Learn more about [Cloud Storage](https://docs.cloud.google.com/storage/docs.md.txt).
- [Known issues for imports and exports](https://docs.cloud.google.com/sql/docs/postgres/known-issues.md.txt#import-export).